package net.sf.gluebooster.demos.pojo.math.library.probabilityTheory;

import java.util.Arrays;
import java.util.List;

import net.sf.gluebooster.demos.pojo.math.Statement;
import net.sf.gluebooster.demos.pojo.math.Statements;
import net.sf.gluebooster.demos.pojo.math.library.Basics;
import net.sf.gluebooster.demos.pojo.math.library.References;
import net.sf.gluebooster.demos.pojo.math.library.algebra.Algebra;
import net.sf.gluebooster.demos.pojo.math.library.logic.Bool;
import net.sf.gluebooster.demos.pojo.math.library.logic.Logic;
import net.sf.gluebooster.demos.pojo.math.library.setTheory.ClassesSets;
import net.sf.gluebooster.demos.pojo.math.library.setTheory.Tuples;
import net.sf.gluebooster.demos.pojo.math.library.setTheory.functions.Mappings;
import net.sf.gluebooster.demos.pojo.math.library.setTheory.operations.Union;
import net.sf.gluebooster.demos.pojo.math.library.setTheory.relations.RelationBinary;
import net.sf.gluebooster.demos.pojo.math.studies.MathMLGenerator;
import net.sf.gluebooster.demos.pojo.math.studies.StudyUnit;
import net.sf.gluebooster.demos.pojo.math.studies.WriteExtended;
import net.sf.gluebooster.java.booster.essentials.utils.ThrowableBoostUtils;

/**
 * Statements of category theory
 * 
 * @author cbauer
 *
 */
public class DescriptiveStatisticsFactory extends Statements {

	protected static final DescriptiveStatisticsFactory SINGLETON = new DescriptiveStatisticsFactory();


	protected DescriptiveStatisticsFactory() {
		super("descriptive statistics", null);

	}

	public static Statement absoluteFrequency(Statement event, Statement totalNumberOfEvents) {
		return SINGLETON.normal("absoluteFrequency", event, totalNumberOfEvents);
	}

	public static Statement relativeFrequency(Statement event) {
		return SINGLETON.normal("relativeFrequency", event);
	}



}
